// io_pt5.cpp
//
// this module reads .pt5 files (generated with X-Stitch Gold)
//
// This module does NOT work.  It (at best) recognizes some pattern 
// files.

//#define _MSP_DEBUG_


#include "vpat_io.h"
#include "io_pt5.h"

#ifdef MSDOS
#include <io.h>
#include <string.h>
#else
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

#define O_BINARY 0

#endif

#include <stdio.h>
#include <fcntl.h>

#include <malloc.h>

//
// Is this an X-Stitch Gold file?
//
// true if yes, false if no
//
// Check is sort-of simple: if the first bytes of the header are X-Stitch
// Gold or the first several bytes are 0x9D 0x00 0x9D 0x00 (etc.), it's 
// a pt5 file.  (Note that the latter may not hold true in all cases, but
// it's probably a good working hypothesis until other charts turn up that 
// turn it on its head)
//

int IsPT5(char *chunk, int size)
{
    int i;

    if (0==strncmp((char *)&chunk[4], "X-Stitch Designer Gold", 22))
      {

#ifdef _MSP_DEBUG_
        fprintf(stderr, "Found X-Stitch Gold (via string)!\n");
#endif

        return true;
      }
    else
      {
        for (i=0; i < 16; i++)
          {
             if ( (chunk[i]!=0) && (chunk[i]!=-99) )
              {
#ifdef _MSP_DEBUG_
                fprintf(stderr, "bailing pt5[%d] on %d!\n", i, chunk[i]);
#endif
                return false;
              }
          }

#ifdef _MSP_DEBUG_
        fprintf(stderr, "Found X-Stitch Gold (via values)!\n");
#endif

        return true;

      }
}

// Some assumptions:
//     pat is checked to see if it's NULL
//     However, the internals are assumed to be NULL before calling, so 
//     the function calling this is responsible for freeing the pattern 
//     data before reuse
int ReadPT5(vpat_chart *pat, char *name)
  {

    return VPATIO_UNKNOWN;

    int pat_fd, num_read, num_extras, version, num_fr_knots, 
        i, x, y, s;                                // looping variables
    unsigned int stitch_count;
    unsigned char in_data[255];

    if (!pat) return VPATIO_BADPAT;
    pat->palette = NULL;
    pat->stitches = NULL;
    pat->bstitches = NULL;

    if ((pat_fd = open(name, O_RDONLY|O_BINARY)) < 0)
      {
        return VPATIO_OPEN;
      }

    // no running off the end here! (this makes the strncpy safe)
    if (strlen(name) > 255) name[255]=0x00;
    strncpy(pat->header.fname, name, strlen(name));

    num_read=read(pat_fd, in_data, 30);
    if (num_read < 30)
      {
        return VPATIO_SHORT;
      }

    if (strncmp((char *)(&in_data[4]), "Win-stitch", 10)!=0)
      {
        return VPATIO_UNKNOWN;
      }

    num_read=read(pat_fd, in_data, 58);
    if (num_read < 58)
      {
        return VPATIO_SHORT;
      }

    pat->header.height        = (int)in_data[10] + (int)((int) in_data[11]<<8);
    pat->header.width         = (int)in_data[12] + (int)((int) in_data[13]<<8);
    pat->header.num_bstitches = (int)in_data[4] + (int)((int) in_data[5]<<8);
    pat->header.num_colors    = (int)in_data[0] + (int)((int) in_data[1]<<8);
    num_fr_knots              = (int)in_data[2] + (int)((int) in_data[3]<<8);

#ifdef _MSP_DEBUG_
    fprintf(stderr, "colors: %d, frknots: %d\n", pat->header.num_colors,
                    num_fr_knots);
#endif

    pat->header.num_stitches = (unsigned int)pat->header.width * 
                               (unsigned int)pat->header.height;

    pat->stitches = (vpat_stitch *)malloc(sizeof(vpat_stitch) *
                                          pat->header.num_stitches);
    if (!pat->stitches)
      {
        return VPATIO_MALLOC;
      }

#ifdef _MSP_DEBUG_
    fprintf(stderr, "reading stitches\n");
#endif

    for (i = 0; i < pat->header.num_stitches; i++)
      {
        num_read=read(pat_fd, in_data, 2);
        if (num_read < 2)
          {
            return VPATIO_SHORT;
          }
        if (in_data[0]==0)
          {
            pat->stitches[i].color = -1;
          }
        else
          {
            pat->stitches[i].color = in_data[0] - 1;
          }
        pat->stitches[i].type = 0;
        pat->stitches[i].second = 0;
      }

    if (pat->header.num_bstitches > 0)
      {

#ifdef _MSP_DEBUG_
        fprintf(stderr, "reading bstitches\n");
#endif

        pat->bstitches = (vpat_bstitch *)malloc((pat->header.num_bstitches +
                                                num_fr_knots) *
                                                (sizeof(vpat_bstitch)));

        if (!pat->bstitches)
          {
            return VPATIO_MALLOC;
          }

        for (i=0; i < pat->header.num_bstitches; i++)
          {
            num_read = read(pat_fd, in_data, 14);
    
            if (num_read < 14)
              return VPATIO_SHORT;

            pat->bstitches[i].color=(int)in_data[0] +
                                   (int)((int) in_data[1] << 8);
            pat->bstitches[i].x1 = ((int)in_data[2] +
                                    (int)((int) in_data[3] << 8))*2;
            pat->bstitches[i].y1 = ((int)in_data[4] +
                                    (int)((int) in_data[5] << 8))*2;
            pat->bstitches[i].x2 = ((int)in_data[6] +
                                    (int)((int) in_data[7] << 8))*2;
            pat->bstitches[i].y2 = ((int)in_data[8] +
                                    (int)((int) in_data[9] << 8))*2;
            pat->bstitches[i].type = 0;   // back stitch

          }

      } // reading back stitches

    if (num_fr_knots > 0)
      {

#ifdef _MSP_DEBUG
    fprintf(stderr, "reading knots(?)\n");
#endif
        if (!pat->bstitches)
          {
            pat->bstitches = (vpat_bstitch *)malloc((num_fr_knots) *
                                                (sizeof(vpat_bstitch)));
          }

        if (!pat->bstitches)
          {
            return VPATIO_MALLOC;
          }

        for (i = 0; i < num_fr_knots; i++)
          {
            num_read = read(pat_fd, in_data, 8);
            if (num_read < 8)
              {
                return VPATIO_SHORT;
              }
            pat->bstitches[i+pat->header.num_bstitches].type = 1;
            pat->bstitches[i+pat->header.num_bstitches].x1 = 2 *
              (int)in_data[2] + (int)((int)in_data[3]<<8);
            pat->bstitches[i+pat->header.num_bstitches].y1 = 2 *
              (int)in_data[4] + (int)((int)in_data[5]<<8);
            pat->bstitches[i+pat->header.num_bstitches].color = 
              (int)in_data[0] + (int)((int)in_data[1]<<1);

          }

        pat->header.num_bstitches += num_fr_knots;

      }

#ifdef _MSP_DEBUG_
    fprintf(stderr, "bstitches read, allocating palette\n");
#endif

    pat->palette = (vpat_color_entry *)malloc(sizeof(vpat_color_entry) *
                                              pat->header.num_colors);
    if (!pat->palette)
      {
        return VPATIO_MALLOC;
      }

#ifdef _MSP_DEBUG_
    fprintf(stderr, "palette allocated, reading %d colors\n",
            pat->header.num_colors);
#endif

    for (i=0; i < pat->header.num_colors; i++)
      {
        num_read = read(pat_fd, in_data, 42);
        if (num_read < 2)
          {
            return VPATIO_SHORT;
          }
        pat->palette[i].used_flag = 0;
        pat->palette[i].red = in_data[4];
        pat->palette[i].green = in_data[5];
        pat->palette[i].blue = in_data[6];
        pat->palette[i].symbol = in_data[37];

#ifdef _MSP_DEBUG_
        fprintf(stderr, "[%d,%d,%d]\n",
                in_data[4], in_data[5], in_data[6]);
#endif

        _colors[i].ResetColor(in_data[4],in_data[5],in_data[6]);
//FIXME: grab "number" from string, and store
        strncpy(pat->palette[i].name, (char *)(&in_data[8]), 26);
        pat->palette[i].DMC_num = 0;
      }

#ifdef _MSP_DEBUG_
    fprintf(stderr, "Colors read, ending\n");
#endif

    close(pat_fd);

    return VPATIO_OK;

  }

