//      vpat_app.cpp:    Source for vpatviewApp class
//=======================================================================

#include <v/vapp.h>             // needed for DOS/Win compile
#include "vpat_app.h"           // Header file

//======================>>> vpatviewApp::vpatviewApp <<<=========================
  vpatviewApp::vpatviewApp(char* name, int sdi, int h, int w) : 
                                                          vApp(name, sdi, h, w)
  {
    // Constructor

   _vpatviewCmdWin = 0;
  }

//======================>>> vpatviewApp::vpatviewApp <<<=========================
  vpatviewApp::~vpatviewApp()
  {
    // Destructor
  }

//=====================>>> vpatviewApp::NewAppWin <<<==========================
  vWindow* vpatviewApp::NewAppWin(vWindow* win, char* name,
    int w, int h, vAppWinInfo* winInfo)
  {
    vAppWinInfo* awinfo = winInfo;
    char *appname = name;

    if (!*name)
      {
        appname = "V Pattern Viewer";           // Default name
      }

    // Create the first window using provided CmdWindow

    _vpatviewCmdWin = (vpatviewCmdWindow*) win;
    if (!_vpatviewCmdWin)
      {
        _vpatviewCmdWin = new vpatviewCmdWindow(appname, w, h);
      }

    if (!awinfo)
        awinfo = new vAppWinInfo(appname);

    return vApp::NewAppWin(_vpatviewCmdWin, appname, w, h, awinfo);
  }

//============================>>> vpatviewApp::Exit <<<===========================
  void vpatviewApp::Exit(void)
  {
    // This is called to close all windows.

    vApp::Exit();               // Default behavior
  }

//======================>>> vpatviewApp::CloseAppWin <<<===========================
  void vpatviewApp::CloseAppWin(vWindow* win)
  {
    // This will be called BEFORE a window has been unregistered or
    // closed.  Default behavior: unregister and close the window.

    vApp::CloseAppWin(win);
  }

//=====================>>> vpatviewApp::AppCommand <<<==============================
  void vpatviewApp::AppCommand(vWindow* win, ItemVal id, ItemVal val, CmdType cType)
  {
    // Commands not processed by the window will be passed here

    vApp::AppCommand(win, id, val, cType);
  }

//=========================>>> vpatviewApp::KeyIn <<<==============================
  void vpatviewApp::KeyIn(vWindow* win, vKey key, unsigned int shift)
  {
    // Key strokes not processed by the window will be passed here

    vApp::KeyIn(win, key, shift);
  }

//###########################################################################
  // The instance of the app
  static vpatviewApp vpatview_App("V Pattern Viewer", 1);        
//###########################################################################

//============================>>> AppMain <<<==============================
  int AppMain(int argc, char** argv)
  {
    // Use AppMain to create the main window

    // The well-behaved X application would probably check for a 
    // -geometry flag or similar to pick the initial size, but 
    // there's not *that* much of a need, is there?

    (void) theApp->NewAppWin(0, "V Pattern Viewer", 550, 350);

    return 0;
  }



