//      vpat_cmd.h:     Header for vpatviewcmdw class
//=======================================================================

#ifndef VPAT_CMD_H
#define VPAT_CMD_H

#include <v/vcmdwin.h>  // So we can use vCmdWindow
#include <v/vmenu.h>    // For the menu pane
#include <v/vutil.h>    // For V Utilities
#include <v/vcmdpane.h> // command pane
#include <v/vstatusp.h> // For the status pane
#include <v/vcolor.h>   // For the colored button

#ifdef vDEBUG
#include <v/vdebug.h>
#endif

#include "vpat_cnv.h"   // vpatviewCanvasPane
#include "vpat_abt.h"   // about dialog
#include "vpat_pge.h"   // page layout dialog

    class vpatviewCmdWindow : public vCmdWindow
      {
        friend int AppMain(int, char**);        // allow AppMain access

      public:           //---------------------------------------- public
        vpatviewCmdWindow(char*, int, int);
        virtual ~vpatviewCmdWindow();
        virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
        virtual void KeyIn(vKey keysym, unsigned int shift);

      protected:        //--------------------------------------- protected

      private:          //--------------------------------------- private

        // Standard elements
        vMenuPane* vpatviewMenu;                // For the menu bar
        vpatviewCanvasPane* vpatviewCanvas;     // For the canvas
        vCommandPane* vpatviewCmdPane;          // for the command pane
        vStatusPane* vpatviewStatus;            // For the status bar

        // Dialogs associated with CmdWindow
        aboutModalDialog* aboutDialog;          // version info
        pageModalDialog* pageDialog;            // page layout

      };
#endif
