//      vpat_cnv.h:     Header for vpatviewCanvasPane class
//=======================================================================

#ifndef VPAT_CNV_H
#define VPAT_CNV_H

// V headers required
#include <v/vcanvas.h>
#include <v/vpen.h>
#include <v/vbrush.h>
#include <v/vmemdc.h>
#include <v/vfont.h>

// needed for the page layout stuff
#include "vpat_pge.h"

// needed for the typedefs
#include "vpat_def.h"

    class vpatviewCanvasPane : public vCanvasPane
      {
      public:           //---------------------------------------- public
        vpatviewCanvasPane();
        virtual ~vpatviewCanvasPane();

        // Scrolling
        virtual void HPage(int shown, int top);
        virtual void VPage(int shown, int top);

        virtual void HScroll(int step);
        virtual void VScroll(int step);

        // Events
        virtual void MouseDown(int x, int y, int button);
        virtual void MouseUp(int x, int y, int button);
        virtual void MouseMove(int x, int y, int button);

        virtual void Redraw(int x, int y, int width, int height);
        virtual void Resize(int newW, int newH);

        // New methods for this class
        int Read(char *name);

        void Print();
        void DrawScaled(vDC *cp);

        void SetChart(vpat_chart *pat);
        vpat_chart *GetChart() { return _pat; };

        void PrintColors(vDC *cp);
        void PrintChart(vDC *cp, int x_start, int y_start, 
                                 int x_per, int y_per, int page_num);

        void UpdateOptions(pageModalDialog *pmd);
        void UpdateScreen();

      protected:        //--------------------------------------- protected

      private:          //--------------------------------------- private

        vpat_chart *_pat;            // the chart
                                     // see vpat_io.h for details

        int _vmem_x, _vmem_y;        // _vmem dimensions
        int _scale_by;               // scaling facter (starts as 8)

        int _print_chart;            // print chart (0=no, 1=yes)
        int _print_type;             // print as colored box (0)
                                     // colored X (1) or symbol (2)
        int _show_grid;              // display grid (1=yes, 0=no)
        int _color_list;             // print color list
        int _print_colors_first;
        int _print_colors_last;

        int _margin;

        int _int_font;

        // some little reusable things for drawing
        vPen _pen;
        vBrush _brush;
        vFont *_font, *_symfont;
        vMemoryDC *_vmem;

      };
#endif
