
#ifndef _VPAT_DEFS_H
#define _VPAT_DEFS_H

// if compiling for Win16 or Win32, MSDOS should be defined
// any suggestions for a better one to catch?
#ifdef MSDOS
#define true 1
#define false 0
#endif

// the following enables the EXIT button and the "Save As VStitch" option.
// it is not recommended, but it is convenient
//#define _MIKE_

// the following enables a menu option to print the internal font -- 
// under X11 *only*
//#define _SAMPLE_SYMBOLS_

#include <v/vcolor.h>

// The following is the number of internal palette entries.  The current 
// set of freely-available files for testing neatly fits within this 
// number, but it can be increased (somewhat) as needed; under an 8-bit 
// X11-based system, increasing this too far *will* exhaust the color map.
#define VPAT_NUM_COLORS 175

typedef struct
  {
    char red, green, blue;              // rgb value for color
    char used_flag;                     // is this entry used?
    int DMC_num,                        // DMC floss number*
        Anchor_num,                     // Anchor floss number
        JPCoats_num;                    // J&P Coats floss number
    char symbol,                        // arbitrary symbol**
         name[255];                     // color name (plenty of room)
  } vpat_color_entry;
//  * 0=BLANC, 1=ECRU
// ** symbols probably don't match the original

typedef struct
  {
    int width, height,                  // pattern width, height
        num_stitches,                   // number of stitches (width*height)
        num_bstitches,                  // number of backstitches
        num_colors;                     // entries in palette
    char fname[256];                    // file name
    char descr[256];                    // instructions/description*
    vpat_color_entry background;        // background color info
  } vpat_chart_info;
//  * this is probably PC-Stitch-centric, but it appears to be a reasonable
//    value

typedef struct
  {
    int type,                           // stitch type
        color,                          // index into palette
        second;                         // index into palette (backup info)
  } vpat_stitch;

typedef struct
  {
    int type;                           // type (0 = backstitch, 1 = fr knot)
    int x1, y1, x2, y2;                 // drawn from (x1,y1) to (x2,y2)
    int color;                          // color of backstitch*
  } vpat_bstitch;
// * color=-1 if chart format doesn't understand color

typedef struct
  {

    vpat_chart_info header;
    vpat_color_entry *palette;
    vpat_stitch *stitches;
    vpat_bstitch *bstitches;

  } vpat_chart;

// the colors are handled here, for ease of palette management while reading 
// the files in
extern vColor _bgcolor;
extern vColor _colors[VPAT_NUM_COLORS];

// and a simple flag: true if a pattern has been loaded, false if there 
// has been no pattern loaded as of yet
extern int _pattern_loaded;

#endif
