//========================================================
//  vpat_pge.h
//========================================================

#ifndef VPAT_PAGELAYOUT_H
#define VPAT_PAGELAYOUT_H

#include <v/vmodald.h>  // derived from vModalDialog
#include <v/vfont.h>    // needed for font stuff

    class pageModalDialog : public vModalDialog
      {
      public:           //---------------------------------------- public
        pageModalDialog(vBaseWindow*);
        virtual ~pageModalDialog();                // Destructor
        virtual void DialogCommand(ItemVal id, ItemVal retval,
                CmdType ctype);

	int GetScaleBy() { return _scale_by; };
	int GetColorList() { return _color_list; };
	int GetShowGrid() { return _show_grid; };
	int GetPrintType() { return _print_type; };
        int GetMargin() { return _margin; };
        int GetPrintChart() { return _print_chart; };
        int GetPCFirst() { return _print_colors_first; };
        int GetPCLast() { return _print_colors_last; };
	vFont *GetFont() { return _font; };
	vFont *GetSymFont() { return _symfont; };
#ifdef _V_SCALED_PRINTER
        int GetIntFont() {return _int_font; };
#endif

      protected:        //--------------------------------------- protected

      private:          //--------------------------------------- private
	int _scale_by,               // scaling factor
	    _color_list,             // 1=yes, 0=no
            _show_grid,              // 1=yes, 0=no
            _print_chart,            // 1=yes, 0=no
            _print_colors_first,     // 1=yes, 0=no
            _print_colors_last,      // 1=yes, 0=no
            _margin,                 // printer margin
#ifdef _V_SCALED_PRINTER
            _int_font,               // 1=use internal font, 0=don't
                                     // (requires printer scaling patch)
#endif
            _print_type;             // 0=box, 1=X, 2=symbol

 	vFont *_font, *_symfont;     // font stuff

      };

#endif

