//=============================================================================
//
//      vpat_prnt.cpp:  Source for vpatviewCanvasPane class
//
// This file contains the printing information for the charts.
//
//=============================================================================

//#define _MSP_DEBUG_

#include "vpat_cnv.h"
#include "vpat_fnt.h"

#include <v/vprinter.h>
#include <v/vprintdc.h>

#ifdef MSDOS
#include <stdio.h>
#endif

#include <malloc.h>

//===================>>> vpatviewCanvasPane::PrintChart <<<====================
  void vpatviewCanvasPane::PrintChart(vDC *cp, int x_start, int y_start, 
                                      int x_per, int y_per, int page_num)
  {
    int i, x, y, h, w, stitch_index, _old_scale, bst_scale;
    char t[12];
    VCursor old_cursor;
    vPoint vp[4];

    cp->Clear();

    h = _pat->header.height;
    w = _pat->header.width;

    if ((x_per + x_start) > w) x_per = w - x_start;
    if ((y_per + y_start) > h) y_per = h - y_start;

    old_cursor = GetCursor();
    SetCursor(VC_Wait);

    switch (_print_type)
      {
        case 0:
          _pen.SetWidth(0);
          _pen.SetStyle(vTransparent);
          cp->SetPen(_pen);
          _brush.SetStyle(vSolid);
          cp->SetBrush(_brush);

          for (y=0 ; y < y_per ; y++)
            {
              for (x=0 ; x < x_per ; x++) 
                {
                    stitch_index = (y + y_start)*w + x + x_start;
                    if (_pat->stitches[stitch_index].color != -1)
                      {
                        _brush.SetColor(_colors[
                                          _pat->stitches[stitch_index].color]);
                        cp->SetBrush(_brush);
                        switch(_pat->stitches[stitch_index].type)
                          {
                            case 0:
                              cp->DrawRectangle(x*_scale_by, y*_scale_by, 
                                                _scale_by, _scale_by);
                              break;

                            case 7:
                              _brush.SetColor(_colors[_pat->
                                              stitches[stitch_index].second]);
                              cp->SetBrush(_brush);

                              vp[0].x = x*_scale_by + _scale_by;
                              vp[0].y = y*_scale_by + _scale_by;
                              vp[1].x = x*_scale_by + _scale_by;
                              vp[1].y = y*_scale_by;
                              vp[2].x = x*_scale_by;
                              vp[2].y = y*_scale_by + _scale_by;
                              vp[3].x = x*_scale_by + _scale_by;
                              vp[3].y = y*_scale_by + _scale_by;
                              cp->DrawPolygon(4, vp);

                            case 1:
                              _brush.SetColor(_colors[_pat->
                                              stitches[stitch_index].color]);
                              cp->SetBrush(_brush);

                              vp[0].x = x*_scale_by;
                              vp[0].y = y*_scale_by;
                              vp[1].x = x*_scale_by + _scale_by;
                              vp[1].y = y*_scale_by;
                              vp[2].x = x*_scale_by;
                              vp[2].y = y*_scale_by + _scale_by;
                              vp[3].x = x*_scale_by;
                              vp[3].y = y*_scale_by;
                              cp->DrawPolygon(4, vp);
                              break;
  
                           case 8:
                              _brush.SetColor(_colors[_pat->
                                              stitches[stitch_index].second]);
                              cp->SetBrush(_brush);

                              vp[0].x = x*_scale_by;
                              vp[0].y = y*_scale_by;
                              vp[1].x = x*_scale_by;
                              vp[1].y = y*_scale_by + _scale_by;
                              vp[2].x = x*_scale_by + _scale_by;
                              vp[2].y = y*_scale_by + _scale_by;
                              vp[3].x = x*_scale_by;
                              vp[3].y = y*_scale_by;
                              cp->DrawPolygon(4, vp);

                           case 2:
                              _brush.SetColor(_colors[_pat->
                                              stitches[stitch_index].color]);
                              cp->SetBrush(_brush);

                              vp[0].x = x*_scale_by;
                              vp[0].y = y*_scale_by;
                              vp[1].x = x*_scale_by + _scale_by;
                              vp[1].y = y*_scale_by;
                              vp[2].x = x*_scale_by + _scale_by;
                              vp[2].y = y*_scale_by + _scale_by;
                              vp[3].x = x*_scale_by;
                              vp[3].y = y*_scale_by;
                              cp->DrawPolygon(4, vp);
                              break;

                           case 3:
                              _brush.SetColor(_colors[_pat->
                                              stitches[stitch_index].color]);
                              cp->SetBrush(_brush);

                              vp[0].x = x*_scale_by;
                              vp[0].y = y*_scale_by;
                              vp[1].x = x*_scale_by + _scale_by;
                              vp[1].y = y*_scale_by + _scale_by;
                              vp[2].x = x*_scale_by;
                              vp[2].y = y*_scale_by + _scale_by;
                              vp[3].x = x*_scale_by;
                              vp[3].y = y*_scale_by;
                              cp->DrawPolygon(4, vp);
                              break;

                           case 4:
                              _brush.SetColor(_colors[_pat->
                                              stitches[stitch_index].color]);
                              cp->SetBrush(_brush);

                              vp[0].x = x*_scale_by;
                              vp[0].y = y*_scale_by + _scale_by;
                              vp[1].x = x*_scale_by + _scale_by;
                              vp[1].y = y*_scale_by;
                              vp[2].x = x*_scale_by + _scale_by;
                              vp[2].y = y*_scale_by + _scale_by;
                              vp[3].x = x*_scale_by;
                              vp[3].y = y*_scale_by + _scale_by;
                              cp->DrawPolygon(4, vp);
                              break;

                           case 6: // HALF-STITCH (/)
                              _brush.SetColor(_colors[_pat->
                                              stitches[stitch_index].color]);
                              cp->SetBrush(_brush);

                              cp->DrawLine(x*_scale_by,
                                           y*_scale_by + _scale_by,
                                           x*_scale_by + _scale_by,
                                           y*_scale_by);
                              break;

                            default:
                              break;
                          }

                      }

                }

            }

          break;

        case 1:
          _pen.SetWidth(_scale_by/4+1);
          _pen.SetStyle(vSolid);
          cp->SetPen(_pen);
          _brush.SetStyle(vTransparent);
          cp->SetBrush(_brush);

          for (y=0 ; y < y_per ; y++)
            {
              for (x=0 ; x < x_per ; x++)
                {
                  stitch_index = (y+y_start)*w + x + x_start;
                    if (_pat->stitches[stitch_index].color != -1)
                      {
                        _pen.SetColor(_colors[_pat->stitches[y*w + x].color]);
                        cp->SetPen(_pen);
                        switch(_pat->stitches[stitch_index].type)
                          {
                            case 0:
                              cp->DrawLine(x*_scale_by, y*_scale_by, 
                                           x*_scale_by + _scale_by, 
                                           y*_scale_by + _scale_by);
                              cp->DrawLine(x*_scale_by,
                                           y*_scale_by + _scale_by,
                                           x*_scale_by + _scale_by,
                                           y*_scale_by);
                              break;

                            case 1:
                            case 7:
                              cp->DrawLine(x*_scale_by, y*_scale_by,
                                           x*_scale_by + _scale_by/2,
                                           y*_scale_by + _scale_by/2);
                              break;

                            case 2:
                            case 8:
                              cp->DrawLine(x*_scale_by + _scale_by,
                                           y*_scale_by,
                                           x*_scale_by + _scale_by/2,
                                           y*_scale_by + _scale_by/2);
                              break;

                            case 3:
                              cp->DrawLine(x*_scale_by,
                                           y*_scale_by + _scale_by,
                                           x*_scale_by + _scale_by/2,
                                           y*_scale_by + _scale_by/2);
                              break;

                            case 4:
                              cp->DrawLine(x*_scale_by + _scale_by,
                                           y*_scale_by + _scale_by,
                                           x*_scale_by + _scale_by/2,
                                           y*_scale_by + _scale_by/2);
                              break;

                            case 6: // HALF-STITCH (/)
                              cp->DrawLine(x*_scale_by,
                                           y*_scale_by + _scale_by,
                                           x*_scale_by + _scale_by,
                                           y*_scale_by);
                              break;

                          }

                        if (_pat->stitches[stitch_index].type==7)
                          {
                            _pen.SetColor(_colors[
                                         _pat->stitches[stitch_index].second]);
                            cp->SetPen(_pen);
                            cp->DrawLine(x*_scale_by + _scale_by,
                                         y*_scale_by + _scale_by,
                                         x*_scale_by + _scale_by/2,
                                         y*_scale_by + _scale_by/2);
                          }
                        else if (_pat->stitches[stitch_index].type==8)
                          {
                            _pen.SetColor(_colors[
                                         _pat->stitches[stitch_index].second]);
                            cp->SetPen(_pen);
                            cp->DrawLine(x*_scale_by,
                                         y*_scale_by + _scale_by,
                                         x*_scale_by + _scale_by/2,
                                         y*_scale_by + _scale_by/2);
                          }


                      }
                }
            }
          break;

        case 2:

        if (_int_font == 1)  // use internal "font" for symbols
          {

            // note that _int_font==0 if _V_SCALED_PRINTER is not 
            // defined, simply because there is no way to change the 
            // value and it is initialized to 0
            //
            // Therefore, without it, this becomes dead code but leaves 
            // the source more readable (fewer ifdef's)

            for (y=0 ; y < y_per ; y++)
              {

                for (x=0 ; x < x_per ; x++)
                  {

                    stitch_index = (y + y_start)*w + x + x_start;

                    if (_pat->stitches[stitch_index].color != -1)
                      {

                        switch (_pat->stitches[stitch_index].type)
                          {

                            case 0:
                              vfnt_draw_symbol(cp,
                                  _pat->palette[
                                    _pat->stitches[stitch_index].color].symbol,
                                  x, y, _scale_by,
                                  _pat->stitches[stitch_index].type);
                              break;

                            case 7:
                              vfnt_draw_symbol(cp,
                                  _pat->palette[
                                    _pat->stitches[stitch_index].second].symbol,
                                  x*2+1, y*2+1, _scale_by/2,
                                  _pat->stitches[stitch_index].type);

                            case 1:
                              vfnt_draw_symbol(cp,
                                  _pat->palette[
                                    _pat->stitches[stitch_index].color].symbol,
                                  x*2, y*2, _scale_by/2,
                                  _pat->stitches[stitch_index].type);
                              break;

                            case 8:
                              vfnt_draw_symbol(cp,
                                  _pat->palette[
                                    _pat->stitches[stitch_index].second].symbol,
                                  x*2, y*2+1, _scale_by/2,
                                  _pat->stitches[stitch_index].type);

                            case 2:
                              vfnt_draw_symbol(cp,
                                  _pat->palette[
                                    _pat->stitches[stitch_index].color].symbol,
                                  x*2+1, y*2, _scale_by/2,
                                  _pat->stitches[stitch_index].type);
                              break;

                            case 3:
                              vfnt_draw_symbol(cp,
                                  _pat->palette[
                                    _pat->stitches[stitch_index].color].symbol,
                                  x*2, y*2+1, _scale_by/2,
                                  _pat->stitches[stitch_index].type);
                              break;

                            case 4:
                              vfnt_draw_symbol(cp,
                                  _pat->palette[
                                    _pat->stitches[stitch_index].color].symbol,
                                  x*2+1, y*2+1, _scale_by/2,
                                  _pat->stitches[stitch_index].type);
                              break;

                            case 6:
                              vfnt_draw_symbol(cp,
                                  _pat->palette[
                                    _pat->stitches[stitch_index].color].symbol,
                                  x*4+1, y*4+1, _scale_by/3,
                                  _pat->stitches[stitch_index].type);
                              cp->DrawLine(x*_scale_by, 
                                           y*_scale_by + _scale_by,
                                           x*_scale_by + _scale_by,
                                           y*_scale_by);
                              break;

                            default:
                              fprintf(stderr, 
                                      "Unsupported stitch %d at (%d,%d)\n", 
                                      _pat->stitches[stitch_index].type,
                                      x, y);

                          } // switch

                      } // if color != -1

                  } // for x

              } // for y

          } // using internal font

        else
          { // use symbol font, not internal font

            // set up pen for symbol drawing
            _pen.SetWidth(1);
            _pen.SetStyle(vSolid);
            _pen.SetColor(vStdColors[vC_Black]);
            cp->SetPen(_pen);
  
            // set up brush to not draw
            _brush.SetStyle(vTransparent);
            cp->SetBrush(_brush);

            _old_scale=_symfont->GetPointSize();
            _symfont->SetFontValues(_symfont->GetFamily(),
                                   _scale_by - 2,  // (so it fits)
                                   _symfont->GetStyle(),
                                   _symfont->GetWeight(),
                                   _symfont->GetUnderlined());
            cp->SetFont(*_symfont);

            for (y=0 ; y < y_per ; y++)
              {
                for (x=0 ; x < x_per ; x++)
                  {
                    stitch_index = (y + y_start)*w + x + x_start;
                    if (_pat->stitches[stitch_index].color != -1)
                      {

                        sprintf(t, "%c", _pat->palette[
                                   _pat->stitches[stitch_index].color].symbol);

                        if (_pat->stitches[stitch_index].type==0)
                          {
                            cp->DrawText(x*_scale_by+3, (y+1)*_scale_by-3, t);
                          }
                        else
                          {
                            _symfont->SetFontValues(_symfont->GetFamily(),
                                               (_scale_by-1)/2, // (so it fits)
                                               _symfont->GetStyle(),
                                               _symfont->GetWeight(),
                                               _symfont->GetUnderlined());
                            cp->SetFont(*_symfont);

                            switch(_pat->stitches[stitch_index].type)
                              {
                                case 1:
                                case 7:
                                  cp->DrawText(x*_scale_by + 1,
                                             y*_scale_by + _scale_by/2, t);
                                  break;

                                case 2:
                                case 8:
                                  cp->DrawText(x*_scale_by + _scale_by/2,
                                             y*_scale_by + _scale_by/2, t);
                                  break;

                                case 3:
                                  cp->DrawText(x*_scale_by + 1,
                                             (y+1)*_scale_by - 1, t);
                                  break;

                                case 4:
                                  cp->DrawText(x*_scale_by + _scale_by/2 + 1,
                                             (y+1)*_scale_by - 1, t);
                                  break;

                                case 6:
                                  cp->DrawText(x*_scale_by + 2,
                                              (y+1)*_scale_by - 2, t);
                                  cp->DrawLine(x*_scale_by,
                                               y*_scale_by + _scale_by,
                                               x*_scale_by + _scale_by,
                                               y*_scale_by);
                                  break;

                              }
                            if (_pat->stitches[stitch_index].type==7)
                              {
                                sprintf(t, "%c", _pat->palette[
                                  _pat->stitches[stitch_index].second].symbol);
                                cp->DrawText(x*_scale_by + _scale_by/2 + 1,
                                             (y+1)*_scale_by - 1, t);
                              }
                            else if (_pat->stitches[stitch_index].type==8)
                              {
                                sprintf(t, "%c", _pat->palette[
                                  _pat->stitches[stitch_index].second].symbol);
                                cp->DrawText(x*_scale_by + 1,
                                             (y+1)*_scale_by - 1, t);
                              }
                            _symfont->SetFontValues(_symfont->GetFamily(),
                                                _scale_by - 2,  // (so it fits)
                                                _symfont->GetStyle(),
                                                _symfont->GetWeight(),
                                                _symfont->GetUnderlined());
                            cp->SetFont(*_symfont);
                          }
                      }
                  }
              }

            _symfont->SetFontValues(_symfont->GetFamily(),
                                   _old_scale,
                                   _symfont->GetStyle(),
                                   _symfont->GetWeight(),
                                   _symfont->GetUnderlined());

            // do a couple magic things to make the grid-scaling work
            _pen.SetWidth(0);
            _pen.SetColor(vStdColors[vC_Red]);
            cp->SetPen(_pen);
          } // end if not using internal font

          break;

        default:
          break;

      }

      if (_show_grid == 1)
        {
          int grd_scale, grd_trx, grd_try, grd_mult, grd_div;

          grd_trx = cp->GetTransX();
          grd_try = cp->GetTransY();
          cp->SetTransX(grd_trx*3);
          cp->SetTransY(grd_try*3);

          cp->GetScale(grd_mult, grd_div);
          cp->SetScale(grd_mult, grd_div*3);
          grd_scale = 3*_scale_by;

          _pen.SetWidth(1);
          _pen.SetStyle(vSolid);
          _pen.SetColor(vStdColors[vC_Black]);
          cp->SetPen(_pen);

          for (i=0; i <= x_per; i++)
            {
              cp->DrawLine(i*grd_scale, 0,
                           i*grd_scale, y_per*grd_scale);
            }
          for (i=0; i <= y_per; i++)
            {
              cp->DrawLine(0, i*grd_scale, 
                           x_per*grd_scale, i*grd_scale);
            }

          cp->SetTransX(grd_trx);  cp->SetTransY(grd_try);
          cp->SetScale(grd_mult, grd_div);
        }

      if (_pat->bstitches)
        {

          // prepare for backstitch drawing
          // _pen.SetWidth(_scale_by/6+1);
#ifdef _V_SCALED_PRINTER
          _pen.SetWidth(2);      // no reason to scale!
#else
          _pen.SetWidth(2);      // no reason to scale!
#endif
          _pen.SetStyle(vSolid);
          _pen.SetColor(vStdColors[vC_Black]);
          cp->SetPen(_pen);
          cp->SetBrush(_brush);

          bst_scale = _scale_by / 2;

          // some page/stitching parameters
          int bst_i, bst_x1, bst_x2, bst_y1, bst_y2, 
              bst_lx, bst_rx, bst_uy, bst_ly, bst_drawit;


          bst_lx = x_start*_scale_by;
          bst_rx = x_start*_scale_by + x_per*_scale_by;
          bst_uy = y_start*_scale_by;
          bst_ly = y_start*_scale_by + y_per*_scale_by;

          for (bst_i=0; bst_i < _pat->header.num_bstitches; bst_i++)
            {

              if (_pat->bstitches[bst_i].type == 1) // it's a french knot
                {

                  bst_x1 = _pat->bstitches[bst_i].x1 * bst_scale /2;
                  bst_y1 = _pat->bstitches[bst_i].y1 * bst_scale /2;

                  cp->DrawEllipse(bst_x1, bst_y1, _scale_by/2, _scale_by/2);

                }
              else // it's a back stitch (type == 0)
                {

              bst_x1 = _pat->bstitches[bst_i].x1 * bst_scale;
              bst_x2 = _pat->bstitches[bst_i].x2 * bst_scale;
              bst_y1 = _pat->bstitches[bst_i].y1 * bst_scale;
              bst_y2 = _pat->bstitches[bst_i].y2 * bst_scale;

              // clipping and drawing
              // first: if it's all on the page, just draw it

              if (   (bst_x1 >= bst_lx) && (bst_x1 <= bst_rx)
                  && (bst_x2 >= bst_lx) && (bst_x2 <= bst_rx)
                  && (bst_y1 >= bst_uy) && (bst_y1 <= bst_ly)
                  && (bst_y2 >= bst_uy) && (bst_y2 <= bst_ly) )
                {
                  cp->DrawLine(bst_x1 - x_start*_scale_by, 
                               bst_y1 - y_start*_scale_by, 
                               bst_x2 - x_start*_scale_by, 
                               bst_y2 - y_start*_scale_by);
                }
              else
                {
                  // clip it (this is the tricky part)

                  // note: if it's entirely within the area, it's already 
                  // been displayed, so anything making it to this part 
                  // either doesn't intersect or it intersects at least once

                  // possible algorithm: check if horizontal or vert.
                  // if so and in appropriate bounds, clip the appropriate part
                  // else, calculate slope and intercepts on each side; if 
                  // intercept on both axes is way out there, discard it 
                  // otherwise clip to intercept

                  bst_drawit = false;

                  // horizontal & vertical first
                  if (bst_x1 == bst_x2)      // vertical line
                    {
                      if ( (bst_x1 >= bst_lx)&&(bst_x2 <= bst_rx) )
                        {
                          if ( ((bst_y1 >= bst_uy)&&(bst_y1 <= bst_ly)) ||
                               ((bst_y2 >= bst_uy)&&(bst_y2 <= bst_ly)) )
                            {
                              if (bst_y1 > bst_ly) bst_y1 = bst_ly;
                              if (bst_y2 > bst_ly) bst_y2 = bst_ly;
                              if (bst_y1 < bst_uy) bst_y1 = bst_uy;
                              if (bst_y2 < bst_uy) bst_y2 = bst_uy;
                              bst_drawit = true;
                            }
                        }
                    }

                  else if (bst_y1 == bst_y2) // horizontal line
                    {
                      if ( (bst_y1 >= bst_uy)&&(bst_y2 <= bst_ly) )
                        {
                          if ( ((bst_x1 >= bst_lx)&&(bst_x1 <= bst_rx)) ||
                               ((bst_x2 >= bst_lx)&&(bst_x2 <= bst_rx)) )
                            {
                              if (bst_x1 < bst_lx) bst_x1 = bst_lx;
                              if (bst_x2 < bst_lx) bst_x2 = bst_lx;
                              if (bst_x1 > bst_rx) bst_x1 = bst_rx;
                              if (bst_x2 > bst_rx) bst_x2 = bst_rx;
                              bst_drawit = true;
                            }
                        }
                    }

                  else                       // neither, so do slope-intercept
                    {
                      float slope;
                      int left_int, top_int, right_int, bottom_int, y_int;
                                             // intercepts (left, top, 
                                             // right, bottom border)
                      int tmp_x, tmp_y;

                      // "normalize" stitch:
                      if (bst_y2 < bst_y1)
                        {
                          // swap stitch
                          tmp_x = bst_x1; bst_x1 = bst_x2; bst_x2 = tmp_x;
                          tmp_y = bst_y1; bst_y1 = bst_y2; bst_y2 = tmp_y;
#ifdef _MSP_DEBUG_
// fprintf(stderr, "Swapped on y\n");
#endif
                        }

                      if (bst_x2 < bst_x1)
                        {
                          // swap stitch
                          tmp_x = bst_x1; bst_x1 = bst_x2; bst_x2 = tmp_x;
                          tmp_y = bst_y1; bst_y1 = bst_y2; bst_y2 = tmp_y;
#ifdef _MSP_DEBUG_
// fprintf(stderr, "Swapped on x\n");
#endif
                        }

//#ifdef _CLIPPING_ON_
                      // we are saved by the fact that we have already 
                      // intercepted the special case (vertical line) which 
                      // could produce a divide-by-zero, and we have 
                      // "normalized" the stitch so that it is guaranteed 
                      // to be to the right of the Y-axis, which makes the 
                      // algorithm easier.  Speed is not a big issue.

                      // algorithm: calculate slope, calculate intercept 
                      // for both X and Y axes, determine if it crosses 
                      // anywhere, and if so recalculate appropriate
                      // endpoints

                      slope = ((float)bst_y2 - (float)bst_y1) / 
                              ((float)bst_x2 - (float)bst_x1);
                      y_int = (int)((float)bst_y1 - (slope * (float)bst_x1));

                      // calculate y intercept when x = left margin, if 
                      // between top & bottom margin, this end is printable 
                      // so clip (x1,y1) to (left margin, y-intercept)
                      //
                      // y = ax + b; a = slope, x = left margin, b is known
                      // so simple plug and go

                      if ( (bst_x2 >= bst_lx) && (bst_x1 <= bst_lx))
                        {
                          left_int = (int)(slope*(float)bst_lx + (float)y_int);
                          if ( ((left_int >= bst_uy)&&(left_int <= bst_ly)) &&
                               ((bst_x2 <= bst_rx)&&(bst_x1 <= bst_lx)) )
                            {
                              bst_x1 = bst_lx; bst_y1 = left_int;
                              bst_drawit = true;
#ifdef _MSP_DEBUG_
  fprintf(stderr, "Clipped on left margin\n");
#endif
                            }
                        }

//#ifdef _CLIPPING_ON_
                      // clip at right margin
                      if ( (bst_x1 <= bst_rx)&&(bst_x2 >= bst_rx) )
                        {
                          right_int = (int)(slope*(float)bst_rx + (float)y_int);
                          if ( ((right_int >= bst_uy)&&(right_int <= bst_ly)) &&
                               ((bst_x1 >= bst_lx) && (bst_x2 >= bst_rx) ) )
                            {
                              bst_x2 = bst_rx; bst_y2 = right_int;
                              bst_drawit = true;
#ifdef _MSP_DEBUG_
  fprintf(stderr, "Clipped on right margin\n");
#endif                   
                            }
                        }

//#ifdef _CLIPPING_ON_

                      // clip on top margin
                      // x=(y-b)/a
                      // y=upper margin, b = y-intercept, a = slope
                      if ( (bst_y1 <= bst_uy)&&(bst_y2 >= bst_uy) )
                        {
                          top_int = (int)((float)(bst_uy - y_int)/slope);
                          if ((top_int >= bst_lx)&&(top_int <= bst_rx))
                            {
                              bst_x1 = top_int; bst_y1 = bst_uy;
                              bst_drawit = true;
#ifdef _MSP_DEBUG_      
  fprintf(stderr, "Clipped on top margin\n");
#endif                   
                            }
                        }

                      if ( (bst_y1 >= bst_uy)&&(bst_y2 <= bst_uy) )
                        {
                          top_int = (int)((float)(bst_uy - y_int)/slope);
                          if ((top_int >= bst_lx)&&(top_int <= bst_rx))
                            {
                              bst_x2 = top_int; bst_y2 = bst_uy;
                              bst_drawit = true;
#ifdef _MSP_DEBUG_
  fprintf(stderr, "Clipped on top margin\n");
#endif
                            }
                        }

//#ifdef _CLIPPING_ON_
                      // clip on bottom margin
                      if ( (bst_y1 <= bst_ly)&&(bst_y2 >= bst_ly) )
                        {
                          bottom_int = (int)((float)(bst_ly - y_int)/slope);
                          if ((bottom_int >= bst_lx)&&(bottom_int <= bst_rx))
                            {
                              bst_x2 = bottom_int; bst_y2 = bst_ly;
                              bst_drawit = true;
#ifdef _MSP_DEBUG_
  fprintf(stderr, "Clipped on bottom margin\n");
#endif
                            }
                        }

//#ifdef _CLIPPING_ON_
                      // clip on bottom margin
                      if ( (bst_y1 >= bst_ly)&&(bst_y2 <= bst_ly) )
                        {
                          bottom_int = (int)((float)(bst_ly - y_int)/slope);
                          if ((bottom_int >= bst_lx)&&(bottom_int <= bst_rx))
                            {
                              bst_x1 = bottom_int; bst_y1 = bst_ly;
                              bst_drawit = true;
#ifdef _MSP_DEBUG_
  fprintf(stderr, "Clipped on bottom margin\n");
#endif
                            }
                        }

//#endif
                    }

                  if (bst_drawit==true)
                    {
                      cp->DrawLine(bst_x1 - x_start*_scale_by,
                                   bst_y1 - y_start*_scale_by,
                                   bst_x2 - x_start*_scale_by,
                                   bst_y2 - y_start*_scale_by);
                    }

                } // else (clipit)

            } // type==0 (backstitch)

            } // for

        } // if(bstitches)

    // Add the page number to the bottom of the page
    // variables start with pgn (PaGe Number) or pgs (PaGe String)
    int pgn_w, pgn_h, pgn_x, pgn_y, pgs_w, pgs_h, pgn_asc, pgn_des;
    char pgn_str[256];

    pgn_w = cp->GetPhysWidth()  - _margin*2;
    pgn_h = cp->GetPhysHeight() - _margin*2;
    sprintf(pgn_str, "Page: %d", page_num);
    cp->SetFont(*_font);

    cp->TextHeight(pgn_asc, pgn_des);
    pgn_x = (pgn_w - cp->TextWidth(pgn_str))/2;
    pgn_y = pgn_h - 2*(pgn_asc + pgn_des);

#ifdef _MSP_DEBUG_
    fprintf(stderr, "pgn_h: %d, pgn_y: %d; pgn_asc: %d, pgn_des: %d\n", 
                 pgn_h,     pgn_y,     pgn_asc,     pgn_des);
#endif

    cp->DrawText(pgn_x, pgn_y, pgn_str);
    // end page number drawing

    SetCursor(old_cursor);

    return;

  }


//=================>>> vpatviewCanvasPane::PrintColors <<<=====================
  void vpatviewCanvasPane::PrintColors(vDC *cp)
  {

    // This is a second-pass at the color table; it is somewhat better 
    // than the first (it supports scaling), but no word-wrap in the 
    // descriptive text/instructions (yet)

    int i, j,                    // for looping through the colors
        row, col,                // current row/col (for color chart)
        txt_scale;               // text scaling factor (point size)
    char t[256];                 // scratch string for printing
    int off_x, off_y;            // margins (not fully supported)

    _pen.SetWidth(1);
    _pen.SetStyle(vSolid);
    _pen.SetColor(vStdColors[vC_Black]);
    cp->SetPen(_pen);

    off_x = 24;                  // left margin (note that printing already 
                                 // sets this over to allow for printer 
                                 // margins)

    _brush.SetStyle(vSolid);
    _brush.SetColor(vStdColors[vC_Black]);
    cp->SetBrush(_brush);

    txt_scale = _font->GetPointSize();
    cp->SetFont(*_font);
    cp->DrawText(off_x, txt_scale*2, _pat->header.fname);
                                 // file name is 2 places down
                                 // (should these be constants or variables?)

// FIXME: add wordwrap!
    sprintf(t, "%s", _pat->header.descr);
    cp->DrawText(off_x, txt_scale*4, t);

    cp->DrawText((txt_scale*3)  + off_x, txt_scale*6, "DMC");
    cp->DrawText((txt_scale*18) + off_x, txt_scale*6, "Name");

    j = 0;
    for (i = 0; i < _pat->header.num_colors ; i++)
      {
        if (_pat->palette[i].used_flag==0)
          {
            sprintf(t, "%d", _pat->palette[i].DMC_num);
            cp->DrawText((txt_scale*3)  + off_x, (j+8)*txt_scale, t);
            cp->DrawText((txt_scale*18) + off_x, (j+8)*txt_scale, 
                         _pat->palette[i].name);
            j++;
          }
      }

    if (_print_type == 2)        // these should be constants instead of 
      {                          // magic numbers
        if (_int_font == 1)
          {
            j = 0;
            for (i = 0; i < _pat->header.num_colors; i++)
              {
                if (_pat->palette[i].used_flag==0)
                  {
                    vfnt_draw_symbol(cp, _pat->palette[i].symbol,
                                     off_x/8, j+7,
                                     txt_scale, 0);
                    j++;
                  }
              }
          }
        else
          {
            cp->SetFont(*_symfont);
            j = 0;
            for (i = 0; i < _pat->header.num_colors; i++)
              {
                if (_pat->palette[i].used_flag==0)
                  {
                    sprintf(t, "%c", _pat->palette[i].symbol);
                    cp->DrawText(off_x, (j+8)*txt_scale, t);
                    j++;
                  }
              }
          }
      }
    else
      {
        j = 0;
        _pen.SetWidth(1);
        _pen.SetColor(vStdColors[vC_Black]);
        cp->SetPen(_pen);

        for (i = 0; i < _pat->header.num_colors; i++)
          {
            if (_pat->palette[i].used_flag==0)
              {
                _brush.SetStyle(vSolid);
                _brush.SetColor(_colors[i]);
                cp->SetBrush(_brush);
                cp->DrawRectangle(off_x, (j+7)*txt_scale, txt_scale, txt_scale);
                j++;
              }
          }
      }

  }

//===============>>> vpatviewCanvasPane::UpdateOptions <<<=====================
  void vpatviewCanvasPane::UpdateOptions(pageModalDialog *pmd)
  {
    int old_scale;

    old_scale = _scale_by;

    _scale_by = pmd->GetScaleBy();
    _show_grid = pmd->GetShowGrid();
    _color_list = pmd->GetColorList();
    _print_chart = pmd->GetPrintChart();
    _print_type = pmd->GetPrintType();
    _margin = pmd->GetMargin();
    _font = pmd->GetFont();
    _symfont = pmd->GetSymFont();

    _print_colors_first = pmd->GetPCFirst();
    _print_colors_last = pmd->GetPCLast();

#ifdef _V_SCALED_PRINTER
    _int_font = pmd->GetIntFont();
#endif

  }

//=====================>>> vpatviewCanvasPane::Print <<<=======================
  void vpatviewCanvasPane::Print()
  {
    // Semi-stupid printing routine; it just redraws everything onto the 
    // printDC -- code ripped from vdraw and modified slightly

    if (!_pat) return;

    vPrintDC pdc;
    vPrinter printer;

    int i;
    char tmp[257];

    if ( (_print_chart==0) && (_color_list==0) )
        return;    // nothing requested to be printed!

// FIXME: stupid assumptions, lousy buggy implementation!
//  for (i=0; i<257; i++) tmp[i]=0;
//  sprintf(tmp, "%s", _pat->header.fname);
//  tmp[strlen(_pat->header.fname) - 4] = 0x00;
//  sprintf(tmp, "%s.ps", tmp);

//  if (!printer.Setup(tmp)) return;  // setup printer
    if (!printer.Setup("|lpr")) return;

    pdc.SetPrinter(printer);                // change to printer that we
                                            // just setup

    if (!pdc.BeginPrinting()) return;       // print to test.ps

    // Okay, we have a valid drawing canvas

    pdc.SetTranslate(_margin,_margin);      // margin, for safety

    int wid, hei, x, y, num_xpages, num_ypages, xstitches_per, ystitches_per;


    wid=pdc.GetPhysWidth(); hei=pdc.GetPhysHeight();

//  num_xpages = (_pat->header.width * _scale_by)/(wid - 72) + 1;
//  num_ypages = (_pat->header.height * _scale_by)/(hei - 72) + 1;
    xstitches_per = (wid - _margin*2) / _scale_by;
    ystitches_per = ((hei - _margin*2) / _scale_by) - 2; // -2 allows room for 
                                                  // "Page: #" at bottom

    num_xpages = (_pat->header.width/xstitches_per)  + 1;
    num_ypages = (_pat->header.height/ystitches_per) + 1;

// Erase "extra" pages, if the width fits perfectly
    if ((_pat->header.width % xstitches_per)==0) num_xpages--;
    if ((_pat->header.height % xstitches_per)==0) num_ypages--;

    if ((_color_list == 1) && (_print_colors_first == 1))
      {
        PrintColors(&pdc);
        pdc.EndPage();
      }

    if (_print_chart == 1)
      {
        for (y=0; y < num_ypages; y++)
          {
            for (x=0; x < num_xpages; x++)
              {
                if ((_color_list == 1) && (_print_colors_first == 1))
                  {
                    pdc.BeginPage();
                   }

                PrintChart(&pdc, x*xstitches_per, y*ystitches_per,
                                 xstitches_per, ystitches_per,
                                 (x + num_xpages*y + 1));

                if ( (x!=(num_xpages-1)) || (y!=(num_ypages-1)))
                  {
                    pdc.EndPage();
                  }

              } // for (x=0)

          } // for (y=0)

      } // if (_print_chart==0)

    if ((_color_list == 1) && (_print_colors_last == 1))
      {
        if (_print_chart == 1)
          {
            pdc.EndPage();
            pdc.BeginPage();
          }
        PrintColors(&pdc);
      }

    pdc.EndPrinting();

  }

